/*
Delayroutine fr den Atmega16
Wartet "us" Microsekunden ab
*1)Taktfrequenz 8MHz	
*2)Taktfrequenz 16MHz
*/

void delayms(unsigned int us) 
{
unsigned char x1;	
    TCCR0 |= (1<<CS01); // Timer mit clk/8 Taktung 
      // jetzt luft der Timer stndig von 0 bis 255
      // bei 8MHz dauert ein Takt 0.125us
      // 256*(0.125us*8) *4 = 256*((1/8Mhz)*8)*4  //weil prescaler nur jeden 8Takt hernimmt zum zhlen
      // =256*1us*4= 1024us = ca. 1 Millisekunde
   while (us)
   {
        
    // *1)
    // x1=4;

    // *2)  man knnte auch einfach den prescaler auf 8*8=64(falls mglich) stellen dann entfllt
    //      die while(x1)-Schleife
    x1=8;
    
    while(x1)  //4 mal auf 256*0.125us*8 warten = ca. 1 Millisekunde
                //8 mal auf 256*0.0625us*8 warten = ca. 1 Millisekunde
    {
       while(!(TIFR & (1<<TOV0)));     // Bei jedem berlauf (255) wird hier ein Flag TOV0 gesetzt
         { } 
    
       TIFR |= (1<<TOV0);  //TOV0-Bit wieder 1 setzten. 
       /*
       ACHTUNG: "Das Flag wird automatisch gelscht, wenn der zugehrige Interrupt-Vektor
                 aufgerufen wird. Es kann jedoch auch gelscht werden, indem eine 
                 logische 1 (!) in das entsprechende Bit geschrieben wird."
       */
     
     x1--; 
    }
    
    us--;
   } 
}

